
int nbLetters = 10;
String[] availableLetters = new String[nbLetters];
String[] nextLetters = new String[nbLetters];
float[] flash  = new float[nbLetters];

String[] possibleConsonnants = new String[]{"t", "n", "s", "r", "h", "d", "l", "c", "m", "f", "p", "b", "v", "j", "g", "q", "k", "w", "x", "z"};
String[] possibleVoyels = new String[]{"e", "a", "o", "i", "u", "y"};
String[] possiblePunct = new String[]{",", ".", "?", ":", "!", "'", "-"};

String typedText = "";

int exported = 0;
int stillFrames = 0;

int lastTypedIndex = 0;

String[] knownWords;

void setup() {
  size(900, 400);
  textFont(loadFont(dataPath("PrestigeEliteStd-Bd-48.vlw")));
  knownWords = loadStrings(dataPath("mots.txt"));
  for (int i=0; i<nbLetters; i++) {
    availableLetters[i]=" ";
    nextLetters[i]=" ";
    flash[i]=1;
  }
  refill(0);
  frameRate(30);
}

void draw() {
  for (int i=0; i<nbLetters; i++) flash[i]=max(flash[i]-0.1, 0);
  background(0xFF);
  for (int i=0; i<nbLetters; i++) {
    fill(0xA0);
    textSize(30);
    text(nextLetters[i], 50+i*30, 40);
    fill(0x70);
    textSize(30+flash[i]*10);
    text(availableLetters[i], 50+i*30, 70);
  }
  textSize(30);
  fill(0);
  text(typedText, 50, 110);
  // if (stillFrames++<3) saveFrame("result/"+nf(exported++, 4)+".png");
}

String toStr(ArrayList<String>a) {
  String r = "";
  for (String s : a) r+=s+" ";
  return r;
}

String toStr(String[] a) {
  String r = "";
  for (String s : a) if (s!=null) r+=s+" ";
  else r+="   ";
  return r;
}

String lastWord() {
  String[] words = splitTokens(typedText, " \n");
  if (words.length>0) return words[words.length-1];
  return null;
}

void keyPressed() {
  boolean accepted = false;
  if (key==BACKSPACE) {
    if (typedText.length()>0) typedText = typedText.substring(0, typedText.length()-1);
  } else if (key==ENTER) {
    typedText += "\n";
  } else if (key==' ') {
    accepted = true;
  } else {
    for (int i=0; i<nbLetters; i++) {
      if (availableLetters[i].equals(str(key).toLowerCase())) {
        accepted = true;
        availableLetters[i]=" ";
        lastTypedIndex = i;
        break;
      }
    }
  }
  if (accepted) {
    typedText += key;
    refill(0);
  }
  stillFrames=0;
}

void refill(int method) {
  String lastWord = lastWord();
  String suggestedLetters = "";
  if (lastWord!=null && !lastWord.equals("")) {
    for (int i=0; i<nbLetters && suggestedLetters.equals(""); i++) {
      if (!availableLetters[i].equals(" ")) {
        String possibleWord = lastWord + availableLetters[i] + nextLetters[lastTypedIndex];
        int randomOffset = floor(random(knownWords.length));
        for (int j=0; j<knownWords.length && suggestedLetters.equals(""); j++) {
          String w = knownWords[(j+randomOffset)%knownWords.length];
          if (w.startsWith(possibleWord)) {
            suggestedLetters = w.substring(possibleWord.length());
            println(w);
          }
        }
      }
    }
  }
  for (int i=0; i<nbLetters; i++) {
    while (availableLetters[i].equals(" ")) {
      String newLetter = "";
      int nbVoyels = 0;
      int nbConsonnants = 0;
      int nbPunct = 0;
      for (String l : availableLetters) for (String p : possibleVoyels) if (l.equals(p)) nbVoyels++;
      for (String l : availableLetters) for (String p : possibleConsonnants) if (l.equals(p)) nbConsonnants++;
      for (String l : availableLetters) for (String p : possiblePunct) if (l.equals(p)) nbPunct++;
      if (nbPunct<2) {
        newLetter=possiblePunct[floor(random(possiblePunct.length))];
      } else if (suggestedLetters.length()>0) {
        newLetter = suggestedLetters.substring(0, 1);
        if (suggestedLetters.length()>1) suggestedLetters = suggestedLetters.substring(1, suggestedLetters.length()-1);
        else suggestedLetters = "";
      } else if (nbVoyels<5) {
        int nbTries = 0;
        boolean found = true;
        while (nbTries++<5 && found) {
          float index = pow(random(1), 1.5);
          newLetter = possibleVoyels[floor(index*possibleVoyels.length)];
          found = false;
          for (String l : availableLetters) if (l.equals(newLetter)) found = true;
        }
      } else {
        int nbTries = 0;
        boolean found = true;
        while (nbTries++<5 && found) {
          float index = pow(random(1), 2.5);
          newLetter = possibleConsonnants[floor(index*possibleConsonnants.length)];
          found = false;
          for (String l : availableLetters) if (l.equals(newLetter)) found = true;
        }
      }

      if (method == 0) {
        availableLetters[i]=nextLetters[i];
        nextLetters[i]=newLetter;
        flash[i]=1;
      }

      if (method == 1) {
        for (int j=i; j<availableLetters.length; j++) {
          if (j==availableLetters.length-1) availableLetters[j] = nextLetters[0];
          else availableLetters[j] = availableLetters[j+1];
        }
        for (int j=0; j<nextLetters.length-1; j++) nextLetters[j] = nextLetters[j+1];
        nextLetters[nextLetters.length-1] = newLetter;
      }
    }
  }
}
